/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/






static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_imm_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 1; /* nop */

    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case PLUS:
          switch (pattern1 (x1))
            {
            case 0:
              if (!(
#line 112 "../../gcc/config/bpf/bpf.md"
(1) && 
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32)))
                return -1;
              return 2; /* addsi3 */

            case 1:
              return 3; /* adddi3 */

            default:
              return -1;
            }

        case MINUS:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern2 (x2, E_SImode) != 0
                  || !
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 4; /* subsi3 */

            case E_DImode:
              if (pattern2 (x2, E_DImode) != 0)
                return -1;
              return 5; /* subdi3 */

            default:
              return -1;
            }

        case NEG:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 6; /* negsi2 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 7; /* negdi2 */

            default:
              return -1;
            }

        case MULT:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 8; /* mulsi3 */

            case 1:
              return 9; /* muldi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case MULT:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              if (!reg_or_imm_operand (operands[2], E_SImode))
                return -1;
              return 10; /* *mulsidi3_zeroextend */

            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x4;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nonimmediate_operand (operands[1], E_HImode))
                    return -1;
                  return 25; /* zero_extendhidi2 */

                case E_QImode:
                  if (!nonimmediate_operand (operands[1], E_QImode))
                    return -1;
                  return 26; /* zero_extendqidi2 */

                case E_SImode:
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  return 27; /* zero_extendsidi2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 11; /* udivsi3 */

            case 1:
              return 12; /* udivdi3 */

            default:
              return -1;
            }

        case DIV:
          switch (pattern1 (x1))
            {
            case 0:
              if (!(
#line 174 "../../gcc/config/bpf/bpf.md"
(TARGET_XBPF) && 
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32)))
                return -1;
              return 13; /* divsi3 */

            case 1:
              if (!
#line 174 "../../gcc/config/bpf/bpf.md"
(TARGET_XBPF))
                return -1;
              return 14; /* divdi3 */

            default:
              return -1;
            }

        case UMOD:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 15; /* umodsi3 */

            case 1:
              return 16; /* umoddi3 */

            default:
              return -1;
            }

        case MOD:
          switch (pattern1 (x1))
            {
            case 0:
              if (!(
#line 197 "../../gcc/config/bpf/bpf.md"
(TARGET_XBPF) && 
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32)))
                return -1;
              return 17; /* modsi3 */

            case 1:
              if (!
#line 197 "../../gcc/config/bpf/bpf.md"
(TARGET_XBPF))
                return -1;
              return 18; /* moddi3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 19; /* andsi3 */

            case 1:
              return 20; /* anddi3 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 21; /* iorsi3 */

            case 1:
              return 22; /* iordi3 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 105 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 23; /* xorsi3 */

            case 1:
              return 24; /* xordi3 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && mov_src_operand (operands[1], E_QImode))
                return 28; /* *movqi */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && mov_src_operand (operands[1], E_HImode))
                return 29; /* *movhi */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && mov_src_operand (operands[1], E_SImode))
                return 30; /* *movsi */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && mov_src_operand (operands[1], E_DImode))
                return 31; /* *movdi */
              break;

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && mov_src_operand (operands[1], E_SFmode))
                return 32; /* *movsf */
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && mov_src_operand (operands[1], E_DFmode))
                return 33; /* *movdf */
              break;

            default:
              break;
            }
          if (GET_CODE (x2) != LABEL_REF
              || GET_CODE (x3) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 45; /* jump */

        case ASHIFTRT:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 318 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 34; /* ashrsi3 */

            case 1:
              return 35; /* ashrdi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 318 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 36; /* ashlsi3 */

            case 1:
              return 37; /* ashldi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern1 (x1))
            {
            case 0:
              if (!
#line 318 "../../gcc/config/bpf/bpf.md"
(bpf_has_alu32))
                return -1;
              return 38; /* lshrsi3 */

            case 1:
              return 39; /* lshrdi3 */

            default:
              return -1;
            }

        case BSWAP:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 40; /* bswaphi2 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 41; /* bswapsi2 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 42; /* bswapdi2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x4 = XEXP (x2, 0);
          if (!ordered_comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[3] = x4;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !reg_or_imm_operand (operands[1], E_SImode)
                  || !
#line 366 "../../gcc/config/bpf/bpf.md"
(bpf_has_jmp32))
                return -1;
              return 43; /* *branch_on_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !reg_or_imm_operand (operands[1], E_DImode))
                return -1;
              return 44; /* *branch_on_di */

            default:
              return -1;
            }

        case CALL:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!call_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          return 48; /* call_value_internal */

        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x2, 0) != 2
              || XINT (x2, 1) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 0)
            return -1;
          x10 = XVECEXP (x2, 0, 0);
          operands[0] = x10;
          x11 = XVECEXP (x2, 0, 1);
          operands[1] = x11;
          if (!imm32_operand (operands[1], E_SImode))
            return -1;
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[0], E_DImode))
                return -1;
              switch (pattern4 (x1))
                {
                case 0:
                  *pnum_clobbers = 4;
                  return 50; /* ldindb */

                case 1:
                  *pnum_clobbers = 4;
                  return 51; /* ldindh */

                case 2:
                  *pnum_clobbers = 4;
                  return 52; /* ldindw */

                case 3:
                  *pnum_clobbers = 4;
                  return 53; /* ldinddw */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
              if (!imm32_operand (operands[0], E_SImode))
                return -1;
              switch (pattern4 (x1))
                {
                case 0:
                  *pnum_clobbers = 4;
                  return 54; /* ldabsb */

                case 1:
                  *pnum_clobbers = 4;
                  return 55; /* ldabsh */

                case 2:
                  *pnum_clobbers = 4;
                  return 56; /* ldabsw */

                case 3:
                  *pnum_clobbers = 4;
                  return 57; /* ldabsdw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) != 2
              || XINT (x2, 1) != 1)
            return -1;
          x10 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x11 = XVECEXP (x2, 0, 1);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern3 (x2, E_SImode) != 0)
                return -1;
              return 58; /* atomic_addsi */

            case E_DImode:
              if (pattern3 (x2, E_DImode) != 0)
                return -1;
              return 59; /* atomic_adddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 46; /* exit */

    case CALL:
      x2 = XEXP (x1, 1);
      operands[1] = x2;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case MEM:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x14 = XEXP (x3, 0);
          operands[0] = x14;
          if (!call_operand (operands[0], E_DImode))
            return -1;
          return 47; /* call_internal */

        case LABEL_REF:
          x14 = XEXP (x3, 0);
          operands[0] = x14;
          return 49; /* sibcall */

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 5)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != UNSPEC
          || XVECLEN (x16, 0) != 2
          || XINT (x16, 1) != 0)
        return -1;
      x17 = XEXP (x15, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 0)
        return -1;
      x18 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x18) != CLOBBER)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 1
          || GET_MODE (x19) != E_DImode)
        return -1;
      x20 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x20) != CLOBBER)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2
          || GET_MODE (x21) != E_DImode)
        return -1;
      x22 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x22) != CLOBBER)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 3
          || GET_MODE (x23) != E_DImode)
        return -1;
      x24 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x24) != CLOBBER)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 4
          || GET_MODE (x25) != E_DImode)
        return -1;
      x26 = XVECEXP (x16, 0, 0);
      operands[0] = x26;
      x27 = XVECEXP (x16, 0, 1);
      operands[1] = x27;
      if (!imm32_operand (operands[1], E_SImode))
        return -1;
      switch (GET_CODE (operands[0]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          switch (pattern5 (x15))
            {
            case 0:
              return 50; /* ldindb */

            case 1:
              return 51; /* ldindh */

            case 2:
              return 52; /* ldindw */

            case 3:
              return 53; /* ldinddw */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          if (!imm32_operand (operands[0], E_SImode))
            return -1;
          switch (pattern5 (x15))
            {
            case 0:
              return 54; /* ldabsb */

            case 1:
              return 55; /* ldabsh */

            case 2:
              return 56; /* ldabsw */

            case 3:
              return 57; /* ldabsdw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
